<script lang="ts" setup>
import navItems from '@/navigation/vertical'
import { themeConfig } from '@themeConfig'
import { useRoute } from 'vue-router'

// Components
import Footer from '@/layouts/components/Footer.vue'
import NavbarThemeSwitcher from '@/layouts/components/NavbarThemeSwitcher.vue'
import UserProfile from '@/layouts/components/UserProfile.vue'
import NavBarI18n from '@core/components/I18n.vue'

// @layouts plugin
import { VerticalNavLayout } from '@layouts'

const route = useRoute()

// Definir la interfaz para Breadcrumb
interface BreadcrumbItem {
  title: string
  href: string
}

// BreadCrumbs
const breadcrumbs = computed(() => {

  const breadcrumbItems = route.meta.breadcrumb as BreadcrumbItem[]
  return breadcrumbItems.map(item => {
    let title = item.title
    let href = item.href

    if (title.startsWith(':')) {
      const paramKey = title.slice(1) // remove the ':' at the start

      title = route.params[paramKey] as string
    }

    if (href.includes(':')) {
      const paramKey = href.split(':')[1] // get the part after ':'

      href = href.replace(`:${paramKey}`, route.params[paramKey] as string)
    }

    return {
      ...item,
      title,
      href,
    }
  })
})

// SECTION: Loading Indicator
const isFallbackStateActive = ref(false)
const refLoadingIndicator = ref<any>(null)

// watching if the fallback state is active and the refLoadingIndicator component is available
watch([isFallbackStateActive, refLoadingIndicator], () => {
  if (isFallbackStateActive.value && refLoadingIndicator.value)
    refLoadingIndicator.value.fallbackHandle()

  if (!isFallbackStateActive.value && refLoadingIndicator.value)
    refLoadingIndicator.value.resolveHandle()
}, { immediate: true })
// !SECTION
</script>

<template>
  <VerticalNavLayout :nav-items="navItems">
    <!-- 👉 navbar -->
    <template #navbar="{ toggleVerticalOverlayNavActive }">
      <div class="d-flex h-100 align-center">
        <IconBtn
          id="vertical-nav-toggle-btn"
          class="ms-n3 d-lg-none"
          @click="toggleVerticalOverlayNavActive(true)"
        >
          <VIcon
            size="26"
            icon="tabler-menu-2"
          />
        </IconBtn>

        <NavbarThemeSwitcher />

        <VSpacer />

        <NavBarI18n
          v-if="themeConfig.app.i18n.enable && themeConfig.app.i18n.langConfig?.length"
          :languages="themeConfig.app.i18n.langConfig"
        />

        <VBtn
          variant="text"
          color="secondary"
          class="pr-0 pl-0"
          rounded
          :to="{ name: 'chat' }"
        >
          <img
            src="@images/icons/sparkles.svg"
            alt="ai"
            class="mr-50"
          >
        </VBtn>

        <!-- <NavbarShortcuts /> -->
        <!-- <NavBarNotifications class="me-2" /> -->
        <UserProfile />
      </div>
    </template>

    <AppLoadingIndicator ref="refLoadingIndicator" />

    <!-- 👉 Pages -->
    <RouterView v-slot="{ Component }">
      <VBreadcrumbs :items="breadcrumbs">
        <template #prepend>
          <VIcon
            icon="tabler-smart-home"
            size="small"
          />
        </template>
        <template #divider>
          <VIcon icon="tabler-chevron-right" />
        </template>
      </VBreadcrumbs>

      <Suspense
        :timeout="0"
        @fallback="isFallbackStateActive = true"
        @resolve="isFallbackStateActive = false"
      >
        <Component :is="Component" />
      </Suspense>
    </RouterView>

    <!-- 👉 Footer -->
    <template #footer>
      <Footer />
    </template>

    <!-- 👉 Customizer -->
    <!-- <TheCustomizer /> -->
  </VerticalNavLayout>
</template>
